using System;
using System.Runtime.InteropServices;
using Extensibility;
using System.Windows.Forms;
using System.Diagnostics;
using System.Reflection;

namespace XLToys
{
    [GuidAttribute("6C8EB0FD-517D-46FB-94AA-BD37DE1640EB"), ProgId("XLToys.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
		private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
		private System.Windows.Forms.ImageList imageList1;
		private AddinExpress.MSO.ADXCommandBarButton btnAboutADXToys2;
		private AddinExpress.MSO.ADXCommandBarButton btnWrapText;
		private AddinExpress.MSO.ADXCommandBarButton btnShrinkToFit;
		private AddinExpress.MSO.ADXCommandBarPopup ppUnderline;
		private AddinExpress.MSO.ADXCommandBarButton btnAlignTop;
		private AddinExpress.MSO.ADXCommandBarButton btnAlignCenter;
		private AddinExpress.MSO.ADXCommandBarButton btnAlignBottom;
		private AddinExpress.MSO.ADXCommandBarButton btnMergeCellsTopdown;
		private AddinExpress.MSO.ADXCommandBarButton btnMergeAndTop;
		private AddinExpress.MSO.ADXCommandBarButton btnMergeAndCenter;
		private AddinExpress.MSO.ADXCommandBarButton btnMergeAndBottom;
		private AddinExpress.MSO.ADXCommandBarPopup ppShowHide;
		private AddinExpress.MSO.ADXCommandBarPopup ppPasteSpecial;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteNone;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteAdd;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteSubtract;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteMultiply;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteDivide;
		private AddinExpress.MSO.ADXCommandBarButton btnSkipBlanks;
		private AddinExpress.MSO.ADXCommandBarButton btnTranspose;
		private AddinExpress.MSO.ADXCommandBarButton btnNone;
		private AddinExpress.MSO.ADXCommandBarButton btnSingle;
		private AddinExpress.MSO.ADXCommandBarButton btnDouble;
		private AddinExpress.MSO.ADXCommandBarButton btnSingleAccounting;
		private AddinExpress.MSO.ADXCommandBarButton btnDoubleAccounting;
		private AddinExpress.MSO.ADXCommandBarButton btnComments;
		private AddinExpress.MSO.ADXCommandBarButton btnZeroValues;
		private AddinExpress.MSO.ADXCommandBarButton btnFormulas;
		private AddinExpress.MSO.ADXCommandBarButton btnGridlines;
		private AddinExpress.MSO.ADXCommandBarButton btnPageBreaks;
		private AddinExpress.MSO.ADXCommandBarButton btnAll;
		private AddinExpress.MSO.ADXCommandBarButton btnAllExceptBorders;
		private AddinExpress.MSO.ADXCommandBarButton btnPasteLinks;
		private AddinExpress.MSO.ADXCommandBarButton btnFormulas_pp;
		private AddinExpress.MSO.ADXCommandBarButton btnValues;
		private AddinExpress.MSO.ADXCommandBarButton btnFormats;
		private AddinExpress.MSO.ADXCommandBarButton btnComments_pp;
		private AddinExpress.MSO.ADXCommandBarButton btnColumnWidths;
		private AddinExpress.MSO.ADXCommandBarButton btnDataValidation;

		private const int xlLinks = 0xFF;
		private const int xlColumnWidths = 8;
		private const int xlDataValidation = 6;
		
		private enum XldMergeCells
		{
			mcTopDown, mcTop, mcBottom, mcCenter
		}

		private enum XldVAlignment
		{
			vaTop, vaCenter, vaBottom
		}

		private enum XldShowHide
		{
			shZeros, shComments, shGridlines, shFormulas, shPageBreaks
		}

		private enum XldCellFormat
		{
			cfWrapText, cfShrinkToFit, cfUnderlineNone, cfUnderlineSingle,
			cfUnderlineDouble, cfUnderlineSingleAccounting, cfUnderlineDoubleAccounting
		}
		
        private System.ComponentModel.IContainer components;
 
        public AddinModule(System.ComponentModel.IContainer container)
        {
            container.Add(this);
            InitializeComponent();
        }

        public AddinModule()
        {
            InitializeComponent();
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AddinModule));
			this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
			this.btnAboutADXToys2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnWrapText = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnShrinkToFit = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.ppUnderline = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
			this.btnNone = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnSingle = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnDouble = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnSingleAccounting = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnDoubleAccounting = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnAlignTop = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnAlignCenter = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnAlignBottom = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnMergeCellsTopdown = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnMergeAndTop = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnMergeAndCenter = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnMergeAndBottom = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.ppShowHide = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
			this.btnComments = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnZeroValues = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnFormulas = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnGridlines = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPageBreaks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.ppPasteSpecial = new AddinExpress.MSO.ADXCommandBarPopup(this.components);
			this.btnAll = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnAllExceptBorders = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteLinks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnFormulas_pp = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnValues = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnFormats = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnComments_pp = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnColumnWidths = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnDataValidation = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteNone = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteAdd = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteSubtract = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteMultiply = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnPasteDivide = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnSkipBlanks = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.btnTranspose = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			// 
			// adxCommandBar1
			// 
			this.adxCommandBar1.CommandBarName = "ADX Toys .NET  (C#)";
			this.adxCommandBar1.CommandBarTag = "81a3c23d-b0e4-4e7d-ba41-fd53e9e6b070";
			this.adxCommandBar1.Controls.Add(this.btnAboutADXToys2);
			this.adxCommandBar1.Controls.Add(this.btnWrapText);
			this.adxCommandBar1.Controls.Add(this.btnShrinkToFit);
			this.adxCommandBar1.Controls.Add(this.ppUnderline);
			this.adxCommandBar1.Controls.Add(this.btnAlignTop);
			this.adxCommandBar1.Controls.Add(this.btnAlignCenter);
			this.adxCommandBar1.Controls.Add(this.btnAlignBottom);
			this.adxCommandBar1.Controls.Add(this.btnMergeCellsTopdown);
			this.adxCommandBar1.Controls.Add(this.btnMergeAndTop);
			this.adxCommandBar1.Controls.Add(this.btnMergeAndCenter);
			this.adxCommandBar1.Controls.Add(this.btnMergeAndBottom);
			this.adxCommandBar1.Controls.Add(this.ppShowHide);
			this.adxCommandBar1.Controls.Add(this.ppPasteSpecial);
			this.adxCommandBar1.Controls.Add(this.btnPasteNone);
			this.adxCommandBar1.Controls.Add(this.btnPasteAdd);
			this.adxCommandBar1.Controls.Add(this.btnPasteSubtract);
			this.adxCommandBar1.Controls.Add(this.btnPasteMultiply);
			this.adxCommandBar1.Controls.Add(this.btnPasteDivide);
			this.adxCommandBar1.Controls.Add(this.btnSkipBlanks);
			this.adxCommandBar1.Controls.Add(this.btnTranspose);
			this.adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.adxCommandBar1.UpdateCounter = 21;
			// 
			// btnAboutADXToys2
			// 
			this.btnAboutADXToys2.BeginGroup = true;
			this.btnAboutADXToys2.Caption = "About ADX Toys 2";
			this.btnAboutADXToys2.ControlTag = "f921bf69-f12c-4e28-92b0-1c4aff94401c";
			this.btnAboutADXToys2.Image = 0;
			this.btnAboutADXToys2.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnAboutADXToys2.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnAboutADXToys2.Tag = "10";
			this.btnAboutADXToys2.UpdateCounter = 13;
			this.btnAboutADXToys2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnWrapText
			// 
			this.btnWrapText.BeginGroup = true;
			this.btnWrapText.Caption = "Wrap Text";
			this.btnWrapText.ControlTag = "e59cfd4d-77c5-46b1-9d24-3135c9f11c57";
			this.btnWrapText.Image = 3;
			this.btnWrapText.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnWrapText.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnWrapText.Tag = "51";
			this.btnWrapText.UpdateCounter = 4;
			this.btnWrapText.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnShrinkToFit
			// 
			this.btnShrinkToFit.Caption = "Shrink To Fit";
			this.btnShrinkToFit.ControlTag = "559a127b-644a-4ae0-9908-45dc21f55ec4";
			this.btnShrinkToFit.Image = 28;
			this.btnShrinkToFit.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnShrinkToFit.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnShrinkToFit.Tag = "52";
			this.btnShrinkToFit.UpdateCounter = 4;
			this.btnShrinkToFit.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// ppUnderline
			// 
			this.ppUnderline.Caption = "Underline";
			this.ppUnderline.Controls.Add(this.btnNone);
			this.ppUnderline.Controls.Add(this.btnSingle);
			this.ppUnderline.Controls.Add(this.btnDouble);
			this.ppUnderline.Controls.Add(this.btnSingleAccounting);
			this.ppUnderline.Controls.Add(this.btnDoubleAccounting);
			this.ppUnderline.ControlTag = "470c32c3-9de2-4ea9-9e28-efb90212ec9d";
			this.ppUnderline.DescriptionText = "Underline";
			this.ppUnderline.UpdateCounter = 3;
			// 
			// btnNone
			// 
			this.btnNone.Caption = "None";
			this.btnNone.ControlTag = "a0055817-8545-43d6-8b69-2738633419c5";
			this.btnNone.Image = 22;
			this.btnNone.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnNone.Tag = "53";
			this.btnNone.UpdateCounter = 7;
			this.btnNone.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnSingle
			// 
			this.btnSingle.Caption = "Single";
			this.btnSingle.ControlTag = "987d5ec7-d0db-4d40-8238-a8c0d2484f89";
			this.btnSingle.Image = 23;
			this.btnSingle.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnSingle.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnSingle.Tag = "54";
			this.btnSingle.UpdateCounter = 8;
			this.btnSingle.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnDouble
			// 
			this.btnDouble.Caption = "Double";
			this.btnDouble.ControlTag = "bf62cd96-82c1-45e7-b9e7-f1df0b42c203";
			this.btnDouble.Image = 20;
			this.btnDouble.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnDouble.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnDouble.Tag = "55";
			this.btnDouble.UpdateCounter = 4;
			this.btnDouble.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnSingleAccounting
			// 
			this.btnSingleAccounting.Caption = "Single Accounting";
			this.btnSingleAccounting.ControlTag = "45e32ba5-2e05-4812-a947-a7360f7db80d";
			this.btnSingleAccounting.Image = 24;
			this.btnSingleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnSingleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnSingleAccounting.Tag = "56";
			this.btnSingleAccounting.UpdateCounter = 4;
			this.btnSingleAccounting.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnDoubleAccounting
			// 
			this.btnDoubleAccounting.Caption = "Double Accounting";
			this.btnDoubleAccounting.ControlTag = "50350dab-5081-4957-8c32-5df4e151ebdf";
			this.btnDoubleAccounting.Image = 21;
			this.btnDoubleAccounting.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnDoubleAccounting.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnDoubleAccounting.Tag = "57";
			this.btnDoubleAccounting.UpdateCounter = 6;
			this.btnDoubleAccounting.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnAlignTop
			// 
			this.btnAlignTop.BeginGroup = true;
			this.btnAlignTop.Caption = "Align Top";
			this.btnAlignTop.ControlTag = "1ae63fc4-8669-4d0c-90dc-07b57b7ca6c8";
			this.btnAlignTop.Image = 31;
			this.btnAlignTop.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnAlignTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnAlignTop.Tag = "20";
			this.btnAlignTop.UpdateCounter = 5;
			this.btnAlignTop.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnAlignCenter
			// 
			this.btnAlignCenter.Caption = "Align Center";
			this.btnAlignCenter.ControlTag = "c95b8a71-1713-4a35-a291-81203cf3f5d9";
			this.btnAlignCenter.Image = 2;
			this.btnAlignCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnAlignCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnAlignCenter.Tag = "21";
			this.btnAlignCenter.UpdateCounter = 3;
			this.btnAlignCenter.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnAlignBottom
			// 
			this.btnAlignBottom.Caption = "Align Bottom";
			this.btnAlignBottom.ControlTag = "d6a5dc02-4978-4e6b-873f-d7bb1302ba87";
			this.btnAlignBottom.Image = 1;
			this.btnAlignBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnAlignBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnAlignBottom.Tag = "22";
			this.btnAlignBottom.UpdateCounter = 3;
			this.btnAlignBottom.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnMergeCellsTopdown
			// 
			this.btnMergeCellsTopdown.BeginGroup = true;
			this.btnMergeCellsTopdown.Caption = "Merge Cells Top-down";
			this.btnMergeCellsTopdown.ControlTag = "301783cd-02e4-4b2c-850b-192d6ab864e5";
			this.btnMergeCellsTopdown.Image = 4;
			this.btnMergeCellsTopdown.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnMergeCellsTopdown.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnMergeCellsTopdown.Tag = "30";
			this.btnMergeCellsTopdown.UpdateCounter = 4;
			this.btnMergeCellsTopdown.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnMergeAndTop
			// 
			this.btnMergeAndTop.Caption = "Merge and Top";
			this.btnMergeAndTop.ControlTag = "e0c37179-3e53-40dd-ae85-f85183e004ff";
			this.btnMergeAndTop.Image = 7;
			this.btnMergeAndTop.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnMergeAndTop.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnMergeAndTop.Tag = "31";
			this.btnMergeAndTop.UpdateCounter = 3;
			this.btnMergeAndTop.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnMergeAndCenter
			// 
			this.btnMergeAndCenter.Caption = "Merge and Center";
			this.btnMergeAndCenter.ControlTag = "bbd4bf9c-d7ba-43f6-b370-be375c65263b";
			this.btnMergeAndCenter.Image = 6;
			this.btnMergeAndCenter.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnMergeAndCenter.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnMergeAndCenter.Tag = "32";
			this.btnMergeAndCenter.UpdateCounter = 3;
			this.btnMergeAndCenter.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnMergeAndBottom
			// 
			this.btnMergeAndBottom.Caption = "Merge and Bottom";
			this.btnMergeAndBottom.ControlTag = "38ff9336-41d2-4fa8-8285-8c485017162a";
			this.btnMergeAndBottom.Image = 5;
			this.btnMergeAndBottom.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnMergeAndBottom.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnMergeAndBottom.Tag = "33";
			this.btnMergeAndBottom.UpdateCounter = 3;
			this.btnMergeAndBottom.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// ppShowHide
			// 
			this.ppShowHide.BeginGroup = true;
			this.ppShowHide.Caption = "Show/Hide";
			this.ppShowHide.Controls.Add(this.btnComments);
			this.ppShowHide.Controls.Add(this.btnZeroValues);
			this.ppShowHide.Controls.Add(this.btnFormulas);
			this.ppShowHide.Controls.Add(this.btnGridlines);
			this.ppShowHide.Controls.Add(this.btnPageBreaks);
			this.ppShowHide.ControlTag = "f0a81aa0-f08c-4ecf-89e3-af8ee4eef0a6";
			// 
			// btnComments
			// 
			this.btnComments.Caption = "Comments";
			this.btnComments.ControlTag = "edf34905-acf5-49ad-9e9c-df61f34ad3fc";
			this.btnComments.Image = 15;
			this.btnComments.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnComments.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnComments.Tag = "41";
			this.btnComments.UpdateCounter = 6;
			this.btnComments.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnZeroValues
			// 
			this.btnZeroValues.Caption = "Zero values";
			this.btnZeroValues.ControlTag = "11d8380d-70b9-458f-8ec2-c1d67cb592d5";
			this.btnZeroValues.Image = 19;
			this.btnZeroValues.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnZeroValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnZeroValues.Tag = "42";
			this.btnZeroValues.UpdateCounter = 4;
			this.btnZeroValues.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnFormulas
			// 
			this.btnFormulas.Caption = "Formulas";
			this.btnFormulas.ControlTag = "2de4fa7b-434d-4941-8400-4dd5e51374bb";
			this.btnFormulas.Image = 16;
			this.btnFormulas.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnFormulas.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnFormulas.Tag = "43";
			this.btnFormulas.UpdateCounter = 4;
			this.btnFormulas.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnGridlines
			// 
			this.btnGridlines.Caption = "Gridlines";
			this.btnGridlines.ControlTag = "5b3f4a7a-d939-47e7-9cf3-f59faf23e8a1";
			this.btnGridlines.Image = 17;
			this.btnGridlines.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnGridlines.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnGridlines.Tag = "44";
			this.btnGridlines.UpdateCounter = 4;
			this.btnGridlines.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPageBreaks
			// 
			this.btnPageBreaks.Caption = "Page breaks";
			this.btnPageBreaks.ControlTag = "18584715-62b1-4d4c-9478-235f546bf085";
			this.btnPageBreaks.Image = 18;
			this.btnPageBreaks.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPageBreaks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnPageBreaks.Tag = "45";
			this.btnPageBreaks.UpdateCounter = 4;
			this.btnPageBreaks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// ppPasteSpecial
			// 
			this.ppPasteSpecial.BeginGroup = true;
			this.ppPasteSpecial.Caption = "Paste Special";
			this.ppPasteSpecial.Controls.Add(this.btnAll);
			this.ppPasteSpecial.Controls.Add(this.btnAllExceptBorders);
			this.ppPasteSpecial.Controls.Add(this.btnPasteLinks);
			this.ppPasteSpecial.Controls.Add(this.btnFormulas_pp);
			this.ppPasteSpecial.Controls.Add(this.btnValues);
			this.ppPasteSpecial.Controls.Add(this.btnFormats);
			this.ppPasteSpecial.Controls.Add(this.btnComments_pp);
			this.ppPasteSpecial.Controls.Add(this.btnColumnWidths);
			this.ppPasteSpecial.Controls.Add(this.btnDataValidation);
			this.ppPasteSpecial.ControlTag = "d087da95-71e0-4049-8a03-61358f12dfc0";
			// 
			// btnAll
			// 
			this.btnAll.Caption = "All";
			this.btnAll.ControlTag = "a649ea2a-38b8-44a8-949b-1df2eca94fc0";
			this.btnAll.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnAll.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnAll.Tag = "61";
			this.btnAll.UpdateCounter = 5;
			this.btnAll.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnAllExceptBorders
			// 
			this.btnAllExceptBorders.Caption = "All except borders";
			this.btnAllExceptBorders.ControlTag = "0e549a1a-1f58-4f36-9df7-cd5bcfdddedd";
			this.btnAllExceptBorders.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnAllExceptBorders.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnAllExceptBorders.Tag = "62";
			this.btnAllExceptBorders.UpdateCounter = 3;
			this.btnAllExceptBorders.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteLinks
			// 
			this.btnPasteLinks.Caption = "Paste Links";
			this.btnPasteLinks.ControlTag = "dd1e2bdf-6b73-4562-ba86-59bb61e5a2e6";
			this.btnPasteLinks.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnPasteLinks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnPasteLinks.Tag = "63";
			this.btnPasteLinks.UpdateCounter = 3;
			this.btnPasteLinks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnFormulas_pp
			// 
			this.btnFormulas_pp.BeginGroup = true;
			this.btnFormulas_pp.Caption = "Formulas";
			this.btnFormulas_pp.ControlTag = "9dbae657-416d-4046-a477-1cc98f260971";
			this.btnFormulas_pp.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnFormulas_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnFormulas_pp.Tag = "64";
			this.btnFormulas_pp.UpdateCounter = 4;
			this.btnFormulas_pp.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnValues
			// 
			this.btnValues.Caption = "Values";
			this.btnValues.ControlTag = "a8aca3c1-02b1-4ae5-8af5-b092424b3fb1";
			this.btnValues.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnValues.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnValues.Tag = "65";
			this.btnValues.UpdateCounter = 3;
			this.btnValues.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnFormats
			// 
			this.btnFormats.Caption = "Formats";
			this.btnFormats.ControlTag = "9e4560c6-4ff8-4e53-8bb0-817face9768f";
			this.btnFormats.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnFormats.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnFormats.Tag = "66";
			this.btnFormats.UpdateCounter = 3;
			this.btnFormats.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnComments_pp
			// 
			this.btnComments_pp.Caption = "Comments";
			this.btnComments_pp.ControlTag = "45869ace-6f9d-4b91-83e1-f50dc77fff16";
			this.btnComments_pp.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnComments_pp.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnComments_pp.Tag = "67";
			this.btnComments_pp.UpdateCounter = 3;
			this.btnComments_pp.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnColumnWidths
			// 
			this.btnColumnWidths.Caption = "Column Widths";
			this.btnColumnWidths.ControlTag = "f80a1fa9-dd0b-4cf5-aefb-747842ab171a";
			this.btnColumnWidths.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnColumnWidths.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnColumnWidths.Tag = "68";
			this.btnColumnWidths.UpdateCounter = 3;
			this.btnColumnWidths.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnDataValidation
			// 
			this.btnDataValidation.Caption = "Data Validation";
			this.btnDataValidation.ControlTag = "eaf44d52-f3c0-412b-946d-843275a48ee7";
			this.btnDataValidation.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.btnDataValidation.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonAutomatic;
			this.btnDataValidation.Tag = "69";
			this.btnDataValidation.UpdateCounter = 3;
			this.btnDataValidation.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteNone
			// 
			this.btnPasteNone.Caption = "Paste None";
			this.btnPasteNone.ControlTag = "05963d19-0ca1-42cd-bb82-dcd0079806ab";
			this.btnPasteNone.Image = 30;
			this.btnPasteNone.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPasteNone.State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
			this.btnPasteNone.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnPasteNone.Tag = "71";
			this.btnPasteNone.UpdateCounter = 6;
			this.btnPasteNone.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteAdd
			// 
			this.btnPasteAdd.Caption = "Paste Add";
			this.btnPasteAdd.ControlTag = "3ed94be6-7410-495c-a39c-4ecff2149489";
			this.btnPasteAdd.Image = 8;
			this.btnPasteAdd.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPasteAdd.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnPasteAdd.Tag = "72";
			this.btnPasteAdd.UpdateCounter = 3;
			this.btnPasteAdd.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteSubtract
			// 
			this.btnPasteSubtract.Caption = "Paste Subtract";
			this.btnPasteSubtract.ControlTag = "891fcd06-9695-47cc-b13d-55d41462da01";
			this.btnPasteSubtract.Image = 13;
			this.btnPasteSubtract.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPasteSubtract.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnPasteSubtract.Tag = "73";
			this.btnPasteSubtract.UpdateCounter = 4;
			this.btnPasteSubtract.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteMultiply
			// 
			this.btnPasteMultiply.Caption = "Paste Multiply";
			this.btnPasteMultiply.ControlTag = "2fb848e6-a4aa-4de1-bd3b-c2a2e720722a";
			this.btnPasteMultiply.Image = 10;
			this.btnPasteMultiply.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPasteMultiply.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnPasteMultiply.Tag = "74";
			this.btnPasteMultiply.UpdateCounter = 3;
			this.btnPasteMultiply.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnPasteDivide
			// 
			this.btnPasteDivide.Caption = "Paste Divide";
			this.btnPasteDivide.ControlTag = "990b6bfc-5ca4-4950-9220-4fb9b3b4aa51";
			this.btnPasteDivide.Image = 9;
			this.btnPasteDivide.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnPasteDivide.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnPasteDivide.Tag = "75";
			this.btnPasteDivide.UpdateCounter = 3;
			this.btnPasteDivide.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnSkipBlanks
			// 
			this.btnSkipBlanks.Caption = "Skip Blanks";
			this.btnSkipBlanks.ControlTag = "ab5ed4c0-e7a6-4408-8752-40309c986a82";
			this.btnSkipBlanks.Image = 12;
			this.btnSkipBlanks.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnSkipBlanks.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnSkipBlanks.Tag = "76";
			this.btnSkipBlanks.UpdateCounter = 4;
			this.btnSkipBlanks.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// btnTranspose
			// 
			this.btnTranspose.Caption = "Transpose";
			this.btnTranspose.ControlTag = "209306a8-485e-4e62-ac5f-1470b044f671";
			this.btnTranspose.Image = 14;
			this.btnTranspose.ImageTransparentColor = System.Drawing.Color.Cyan;
			this.btnTranspose.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
			this.btnTranspose.Tag = "77";
			this.btnTranspose.UpdateCounter = 4;
			this.btnTranspose.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.DoClick);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// AddinModule
			// 
			this.AddinName = "ADX Toys .NET (C#)";
			this.Description = "ADX Toys .NET for Excel (C#)";
			this.Images = this.imageList1;
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
			this.OnError += new AddinExpress.MSO.ADXError_EventHandler(this.XLToysConnect_OnError);
			this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.XLToysConnect_AddinInitialize);

		}
        #endregion
 
        #region ADX Implementation
 
        /// <summary>
        /// Required method for ADX support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        public override System.ComponentModel.IContainer GetContainer()
        {
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private void XLToysConnect_AddinInitialize(object sender, System.EventArgs e)
		{
			if (StartMode == AddinExpress.MSO.ADXStartMode.smFirstStart)
			{
				adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarFloating;
				DoAbout();
			}
		}

		private void DoClick(object sender)
		{
			switch((sender as AddinExpress.MSO.ADXCommandBarControl).Tag)
			{
				case "10":
					DoAbout();
					break;

				case "51":
					DoCellFormat(XldCellFormat.cfWrapText);
					break;
				case "52":
					DoCellFormat(XldCellFormat.cfShrinkToFit);
					break;
				case "53":
					DoCellFormat(XldCellFormat.cfUnderlineNone);
					break;
				case "54":
					DoCellFormat(XldCellFormat.cfUnderlineSingle);
					break;
				case "55":
					DoCellFormat(XldCellFormat.cfUnderlineDouble);
					break;
				case "56":
					DoCellFormat(XldCellFormat.cfUnderlineSingleAccounting);
					break;
				case "57":
					DoCellFormat(XldCellFormat.cfUnderlineDoubleAccounting);
					break;

				case "20":
					DoVAlign(XldVAlignment.vaTop);
					break;
				case "21":
					DoVAlign(XldVAlignment.vaCenter);
					break;
				case "22": 
					DoVAlign(XldVAlignment.vaBottom);
					break;

				case "30": 
					DoMerge(XldMergeCells.mcTopDown);
					break;
				case "31": 
					DoMerge(XldMergeCells.mcTop);
					break;
				case "32": 
					DoMerge(XldMergeCells.mcCenter);
					break;
				case "33": 
					DoMerge(XldMergeCells.mcBottom);
					break;

				case "41": 
					DoShowHide(XldShowHide.shComments);
					break;
				case "42": 
					DoShowHide(XldShowHide.shZeros);
					break;
				case "43": 
					DoShowHide(XldShowHide.shFormulas);
					break;
				case "44": 
					DoShowHide(XldShowHide.shGridlines);
					break;
				case "45": 
					DoShowHide(XldShowHide.shPageBreaks);
					break;

				case "61": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteAll);
					break;
				case "62": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteAllExceptBorders);
					break;
				case "63": 
					DoPasteSpecial(xlLinks);
					break;
				case "64": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormulas);
					break;
				case "65": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteValues);
					break;
				case "66": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteFormats);
					break;
				case "67": 
					DoPasteSpecial((int)Excel.XlPasteType.xlPasteComments);
					break;
				case "68": 
					DoPasteSpecial(xlColumnWidths);
					break;
				case "69": 
					DoPasteSpecial(xlDataValidation);
					break;

				case "71":
				case "72":
				case "73":
				case "74":
				case "75":
					if ((sender as AddinExpress.MSO.ADXCommandBarButton).State == 
						AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp)
					{
						for(int i=13; i<=17; i++)
						{
							if (i != adxCommandBar1.Controls.IndexOf(sender as AddinExpress.MSO.ADXCommandBarButton))
							{
								(adxCommandBar1.Controls[i] as AddinExpress.MSO.ADXCommandBarButton).State = 
									AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp;
							}
						}
						(sender as AddinExpress.MSO.ADXCommandBarButton).State = 
							AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
					}
    				break;
				case "76":
				case "77":
					if ((sender as AddinExpress.MSO.ADXCommandBarButton).State == AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp)
						(sender as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown;
					else
						(sender as AddinExpress.MSO.ADXCommandBarButton).State = AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonUp;
					break;
			}
		}

		private void DoAbout()
		{
			string toysVersion = Assembly.GetExecutingAssembly().GetName().Version.ToString(4);
			string adxVersion = Assembly.GetAssembly(typeof(AddinExpress.MSO.ADXAddinModule)).GetName().Version.ToString(4);
			AboutForm about = new AboutForm();
			about.LabelFor.Text = String.Format(about.LabelFor.Text, new Object[]{"Microsoft"+Convert.ToChar(174)+" Excel"});
			about.LabelVersion.Text = String.Format(about.LabelVersion.Text, new Object[]{toysVersion});
			about.LabelADXVersion.Text = String.Format(about.LabelADXVersion.Text, new Object[]{adxVersion});
			about.ShowDialog();
			about.Dispose();
		}

		private Excel._Application ExcelHost()
		{
			return (HostApplication as Excel._Application);
		}

		private Excel.Range GetSelectedRange()
		{
			Excel._Application excelApp = HostApplication as Excel._Application;
			return (excelApp.Selection as Excel.Range);
		}

		private void DoCellFormat(XldCellFormat format)
		{
			Excel.Range range = GetSelectedRange();
			if (range != null)
			{
				switch(format)
				{
					case XldCellFormat.cfWrapText:
						range.ShrinkToFit = false;
						range.WrapText = !(bool)range.WrapText;
						break;
					case XldCellFormat.cfShrinkToFit:
						range.WrapText = false;
						range.ShrinkToFit = !(bool)range.ShrinkToFit;
						break;
					case XldCellFormat.cfUnderlineDouble:
						range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDouble;
						break;
					case XldCellFormat.cfUnderlineDoubleAccounting:
						range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleDoubleAccounting;
						break;
					case XldCellFormat.cfUnderlineNone:
						range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleNone;
						break;
					case XldCellFormat.cfUnderlineSingle:
						range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingle;
						break;
					case XldCellFormat.cfUnderlineSingleAccounting:
						range.Font.Underline = Excel.XlUnderlineStyle.xlUnderlineStyleSingleAccounting;
						break;
				}
				range = null;
			}
		}

		private void DoVAlign(XldVAlignment alignment)
		{
			Excel.Range range = GetSelectedRange();
			if (range != null)
			{
				switch(alignment)
				{
					case XldVAlignment.vaBottom:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom;
						break;
					case XldVAlignment.vaCenter:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
						break;
					case XldVAlignment.vaTop:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop;
						break;
				}
				range = null;
			}
		}

		private void DoMerge(XldMergeCells merge)
		{
			Excel.Range range = GetSelectedRange();
			if (range != null)
			{
				if (merge == XldMergeCells.mcTopDown)
				{
					for(int j=1; j<=range.Areas.Count; j++)
					{
						for(int i=1; i<=range.Areas[j].Columns.Count; i++)
						{
							(range.Areas[j].Columns[i, Type.Missing] as Excel.Range).Merge(false);
						}
					}
				}
				else
					range.Merge(false);
				switch(merge)
				{
					case XldMergeCells.mcTop:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignTop;
						break;
					case XldMergeCells.mcBottom:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignBottom;
						break;
					case XldMergeCells.mcCenter:
						range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
						break;
				}
				range = null;
			}
		}

		private void DoShowHide(XldShowHide sh)
		{
			Excel._Worksheet ws;
			Excel.Range range = GetSelectedRange();
			if (range != null)
			{
				switch(sh)
				{
					case XldShowHide.shZeros:
						Excel.Window wnd = ExcelHost().ActiveWindow;
						if (wnd != null)
							wnd.DisplayZeros = !(bool)wnd.DisplayZeros;
						break;
					case XldShowHide.shComments:
						ws = ExcelHost().ActiveSheet as Excel._Worksheet;
						if (ws != null)
						{
							for(int i=1; i<=ws.Comments.Count; i++)
							{
								ws.Comments[i].Visible = !ws.Comments[i].Visible;
							}
						}
						break;
					case XldShowHide.shPageBreaks:
						ws = ExcelHost().ActiveSheet as Excel._Worksheet;
						if (ws != null)
						{
							ws.DisplayAutomaticPageBreaks = !ws.DisplayAutomaticPageBreaks;
						}
						break;
					case XldShowHide.shGridlines:
						ExcelHost().ActiveWindow.DisplayGridlines = !ExcelHost().ActiveWindow.DisplayGridlines;
						break;
					case XldShowHide.shFormulas:
						ExcelHost().ActiveWindow.DisplayFormulas = !ExcelHost().ActiveWindow.DisplayFormulas;
						break;
				}
				range = null; ws = null;
			}
		}

		private AddinExpress.MSO.ADXCommandBarControl ControlByTag(string tag)
		{
			for(int i=0; i<adxCommandBar1.Controls.Count; i++)
			{
				if (adxCommandBar1.Controls[i].Tag == tag) return adxCommandBar1.Controls[i];
			}
			return null;
		}

		private void DoPasteSpecial(int paste)
		{
			Excel.Range range = GetSelectedRange();
			if (range != null)
			{
				Excel.XlPasteSpecialOperation operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone;
				for(int i=71; i<=75; i++)
				{
					if ((ControlByTag(i.ToString()) as AddinExpress.MSO.ADXCommandBarButton).State == 
						AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown)
					{
						switch(i)
						{
							case 71:
								operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationNone;
								break;
							case 72:
								operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationAdd;
								break;
							case 73:
								operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationSubtract;
								break;
							case 74:
								operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationMultiply;
								break;
							case 75:
								operation = Excel.XlPasteSpecialOperation.xlPasteSpecialOperationDivide;
								break;
						}
						break;
					}
				}
				bool skipBlanks = ((ControlByTag("76") as AddinExpress.MSO.ADXCommandBarButton).State == 
					AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown);
				bool transpose = ((ControlByTag("77") as AddinExpress.MSO.ADXCommandBarButton).State == 
					AddinExpress.MSO.ADXMsoButtonState.adxMsoButtonDown);
				switch(paste)
				{
					case xlLinks:
						if (range.Parent is Excel._Worksheet)
							(range.Parent as Excel._Worksheet).Paste(Type.Missing, true);
						break;
					default:
						range.PasteSpecial((Excel.XlPasteType)paste, operation, skipBlanks, transpose);
						break;
				}
				range = null;
			}
		}

		private void XLToysConnect_OnError(AddinExpress.MSO.ADXErrorEventArgs e)
		{
			e.Handled = true;
			MessageBox.Show(e.ADXError.Message, e.ADXError.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
	}
}

